Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/PasteTool.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/PasteTool.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/PasteTool.cs	(revision 4068)
@@ -1,155 +1,135 @@
 using System;
-using System.Diagnostics;
 using System.Collections;
 using System.Drawing;
+using System.IO;
+using System.Runtime.Serialization.Formatters.Binary;
 using System.Windows.Forms;
-using System.IO;
-using System.Runtime.Serialization;
-using System.Runtime.Serialization.Formatters.Binary;
-namespace Netron.Diagramming.Core
-{
-    // ----------------------------------------------------------------------
+namespace Netron.Diagramming.Core {
+  // ----------------------------------------------------------------------
+  /// <summary>
+  /// This tool pastes items from the clipboard to the canvas.
+  /// </summary>
+  // ----------------------------------------------------------------------
+  public class PasteTool : AbstractTool {
+    // ------------------------------------------------------------------
     /// <summary>
-    /// This tool pastes items from the clipboard to the canvas.
+    /// Specifies where the items from the clipboard will be 
+    /// inserted at.
     /// </summary>
-    // ----------------------------------------------------------------------
-    public class PasteTool : AbstractTool
-    {
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Specifies where the items from the clipboard will be 
-        /// inserted at.
-        /// </summary>
-        // ------------------------------------------------------------------
-        public static Point InsertionPoint = new Point(50, 50);
+    // ------------------------------------------------------------------
+    public static Point InsertionPoint = new Point(50, 50);
 
-        #region Fields
-        #endregion
+    #region Fields
+    #endregion
 
-        #region Constructor
-        /// <summary>
-        /// Initializes a new instance of the <see cref="T:HoverTool"/> class.
-        /// </summary>
-        /// <param name="name">The name of the tool.</param>
-        public PasteTool(string name)
-            : base(name)
-        {
+    #region Constructor
+    /// <summary>
+    /// Initializes a new instance of the <see cref="T:HoverTool"/> class.
+    /// </summary>
+    /// <param name="name">The name of the tool.</param>
+    public PasteTool(string name)
+      : base(name) {
+    }
+    #endregion
+
+    #region Methods
+
+    /// <summary>
+    /// Called when the tool is activated.
+    /// </summary>
+    protected override void OnActivateTool() {
+      try {
+        // Used to get a collection of entities from the 
+        // NetronClipboard.
+        Type entitiesType = typeof(CollectionBase<IDiagramEntity>);
+
+        // First calculate the insertion point based on the
+        // current location of the cursor.
+        InsertionPoint = Point.Round(
+        Controller.View.ViewToWorld(
+        Controller.View.DeviceToView(
+        Controller.ParentControl.PointToClient(Cursor.Position))));
+
+        IDataObject data = Clipboard.GetDataObject();
+        string format = typeof(CopyTool).FullName;
+        if (data.GetDataPresent(format)) {
+          MemoryStream stream = data.GetData(format) as MemoryStream;
+          CollectionBase<IDiagramEntity> collection = null;
+          GenericFormatter<BinaryFormatter> f =
+              new GenericFormatter<BinaryFormatter>();
+          //Anchors collection is a helper collection to re-connect connectors to their parent
+          Anchors.Clear();
+          //but is it actually a stream coming this application?
+          collection = f.Deserialize<CollectionBase<IDiagramEntity>>(stream);
+          UnwrapBundle(collection);
+
+        } else if (NetronClipboard.ContainsData(entitiesType)) {
+          CollectionBase<IDiagramEntity> collection =
+              (CollectionBase<IDiagramEntity>)NetronClipboard.Get(
+              entitiesType);
+
+          UnwrapBundle(collection.DeepCopy());
+        } else if (data.GetDataPresent(DataFormats.Bitmap)) {
+          Bitmap bmp = data.GetData(DataFormats.Bitmap) as Bitmap;
+          if (bmp != null) {
+            #region Unwrap into an image shape
+            //TODO: Insert the image shape here
+            ImageShape shape = new ImageShape();
+            shape.Image = bmp;
+            shape.Location = InsertionPoint;
+            Controller.Model.AddShape(shape);
+            #endregion
+          }
+        } else if (data.GetDataPresent(DataFormats.Text)) {
+          string text = (string)data.GetData(typeof(string));
+          TextOnly textShape = new TextOnly(Controller.Model);
+          textShape.Text = text;
+          textShape.Location = InsertionPoint;
+          Controller.Model.AddShape(textShape);
         }
-        #endregion
+      }
+      catch (Exception exc) {
+        throw new InconsistencyException("The Paste operation failed.", exc);
+      }
+      finally {
+        DeactivateTool();
+      }
 
-        #region Methods
+    }
 
-        /// <summary>
-        /// Called when the tool is activated.
-        /// </summary>
-        protected override void OnActivateTool()
-        {
-            try
-            {
-                // Used to get a collection of entities from the 
-                // NetronClipboard.
-                Type entitiesType = typeof(CollectionBase<IDiagramEntity>);
+    #endregion
 
-                // First calculate the insertion point based on the
-                // current location of the cursor.
-                InsertionPoint = Point.Round(
-                Controller.View.ViewToWorld(
-                Controller.View.DeviceToView(
-                Controller.ParentControl.PointToClient(Cursor.Position))));
+    /// <summary>
+    /// Unwraps the given bundle to the diagram.
+    /// </summary>
+    /// <param name="collection">CollectionBase<IDiagramEntity></param>
+    void UnwrapBundle(CollectionBase<IDiagramEntity> collection) {
+      if (collection != null) {
+        #region Unwrap the bundle
+        this.Controller.Model.Unwrap(collection);
 
-                IDataObject data = Clipboard.GetDataObject();
-                string format = typeof(CopyTool).FullName;
-                if (data.GetDataPresent(format))
-                {
-                    MemoryStream stream = data.GetData(format) as MemoryStream;
-                    CollectionBase<IDiagramEntity> collection = null;
-                    GenericFormatter<BinaryFormatter> f =
-                        new GenericFormatter<BinaryFormatter>();
-                    //Anchors collection is a helper collection to re-connect connectors to their parent
-                    Anchors.Clear();
-                    //but is it actually a stream coming this application?
-                    collection = f.Deserialize<CollectionBase<IDiagramEntity>>(stream);
-                    UnwrapBundle(collection);
+        Rectangle rec = Utils.BoundingRectangle(collection);
 
-                }
-                else if (NetronClipboard.ContainsData(entitiesType))
-                {
-                    CollectionBase<IDiagramEntity> collection =
-                        (CollectionBase<IDiagramEntity>)NetronClipboard.Get(
-                        entitiesType);
+        // The InsertionPoint specifies where the pasted
+        // entities should be.  So, shift each entity in the
+        // collection to the InsertionPoint.
+        Point delta = new Point(
+            InsertionPoint.X - rec.Location.X,
+            InsertionPoint.Y - rec.Location.Y);
+        //delta.Offset(rec.Location);
 
-                    UnwrapBundle(collection.DeepCopy());
-                }  
-                else if (data.GetDataPresent(DataFormats.Bitmap))
-                {
-                    Bitmap bmp = data.GetData(DataFormats.Bitmap) as Bitmap;
-                    if (bmp != null)
-                    {
-                        #region Unwrap into an image shape
-                        //TODO: Insert the image shape here
-                        ImageShape shape = new ImageShape();
-                        shape.Image = bmp;
-                        shape.Location = InsertionPoint;
-                        Controller.Model.AddShape(shape);
-                        #endregion
-                    }
-                }
-                else if (data.GetDataPresent(DataFormats.Text))
-                {
-                    string text = (string) data.GetData(typeof(string));
-                    TextOnly textShape = new TextOnly(Controller.Model);
-                    textShape.Text = text;
-                    textShape.Location = InsertionPoint;
-                    Controller.Model.AddShape(textShape);
-                }    
-            }
-            catch (Exception exc)
-            {
-                throw new InconsistencyException("The Paste operation failed.", exc);
-            }
-            finally
-            {
-                DeactivateTool();
-            }
-
+        foreach (IDiagramEntity entity in collection) {
+          entity.MoveBy(delta);
         }
 
+        // Recalculate the bounding rectangle and invalidate
+        // that area on the canvas.
+        rec = Utils.BoundingRectangle(collection);
+        rec.Inflate(30, 30);
+        this.Controller.View.Invalidate(rec);
         #endregion
-
-        /// <summary>
-        /// Unwraps the given bundle to the diagram.
-        /// </summary>
-        /// <param name="collection">CollectionBase<IDiagramEntity></param>
-        void UnwrapBundle(CollectionBase<IDiagramEntity> collection)
-        {
-            if (collection != null)
-            {
-                #region Unwrap the bundle
-                this.Controller.Model.Unwrap(collection);
-
-                Rectangle rec = Utils.BoundingRectangle(collection);
-
-                // The InsertionPoint specifies where the pasted
-                // entities should be.  So, shift each entity in the
-                // collection to the InsertionPoint.
-                Point delta = new Point(
-                    InsertionPoint.X - rec.Location.X,
-                    InsertionPoint.Y - rec.Location.Y);
-                //delta.Offset(rec.Location);
-
-                foreach (IDiagramEntity entity in collection)
-                {
-                    entity.MoveBy(delta);
-                }
-
-                // Recalculate the bounding rectangle and invalidate
-                // that area on the canvas.
-                rec = Utils.BoundingRectangle(collection);
-                rec.Inflate(30, 30);
-                this.Controller.View.Invalidate(rec);
-                #endregion
-            }
-        }
+      }
     }
+  }
 
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/PolygonTool.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/PolygonTool.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/PolygonTool.cs	(revision 4068)
@@ -1,137 +1,119 @@
 using System;
-using System.Diagnostics;
-using System.Collections;
-using System.Collections.Generic;
 using System.Drawing;
 using System.Windows.Forms;
 
-namespace Netron.Diagramming.Core
-{
-   
-    class PolygonTool : AbstractTool, IMouseListener, IKeyboardListener
-    {
+namespace Netron.Diagramming.Core {
 
-        #region Fields
-        /// <summary>
-        /// the location of the mouse when the motion starts
-        /// </summary>
-        
-        private bool doDraw;
-        private Point[] points;
-        #endregion
+  class PolygonTool : AbstractTool, IMouseListener, IKeyboardListener {
 
-        #region Constructor
-        /// <summary>
-        /// Initializes a new instance of the <see cref="T:PolygonTool"/> class.
-        /// </summary>
-        /// <param name="name">The name of the tool.</param>
-        public PolygonTool(string name) : base(name)
-        {
-        }
-        #endregion
+    #region Fields
+    /// <summary>
+    /// the location of the mouse when the motion starts
+    /// </summary>
 
-        #region Methods
+    private bool doDraw;
+    private Point[] points;
+    #endregion
 
-        /// <summary>
-        /// Called when the tool is activated.
-        /// </summary>
-        protected override void OnActivateTool()
-        {
-            Controller.View.CurrentCursor =CursorPalette.Cross;
-            this.SuspendOtherTools(); 
-            doDraw = false;
-            points = new Point[1];
-        }
+    #region Constructor
+    /// <summary>
+    /// Initializes a new instance of the <see cref="T:PolygonTool"/> class.
+    /// </summary>
+    /// <param name="name">The name of the tool.</param>
+    public PolygonTool(string name)
+      : base(name) {
+    }
+    #endregion
 
-        /// <summary>
-        /// Handles the mouse down event
-        /// </summary>
-        /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
-        /// <returns>Returns 'true' if the event was handled, otherwise 'false'.</returns>
-        public bool MouseDown(MouseEventArgs e)
-        {
-            if (e == null)
-                throw new ArgumentNullException("The argument object is 'null'");
-            if (e.Button == MouseButtons.Left && Enabled && !IsSuspended)
-            {
-                    Array.Resize<Point>(ref points, points.Length + 1);
-                    points[points.Length-2]= e.Location;
-                    doDraw = true;
-                    return true;           
-            }
-            return false;
-        }
+    #region Methods
 
-        /// <summary>
-        /// Handles the mouse move event
-        /// </summary>
-        /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
-        public void MouseMove(MouseEventArgs e)
-        {
-            if (e == null)
-                throw new ArgumentNullException("The argument object is 'null'");
-            Point point = e.Location;
-            if(IsActive && doDraw)
-            {
-                points[points.Length - 1] = e.Location;                
-                Controller.View.PaintGhostLine( MultiPointType.Polygon, points);
-                //Controller.View.Invalidate(System.Drawing.Rectangle.Inflate(Controller.View.Ghost.Rectangle, 20, 20));
-                //TODO: find a more performant way to invalidate the area
-                Controller.View.Invalidate();
-            }            
-        }
-        /// <summary>
-        /// 
-        /// </summary>
-        /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
-        public void MouseUp(MouseEventArgs e)
-        {
-            if (IsActive)
-            {
-               
-            }
-        }
-        private void Package()
-        {
-            if ((points == null) ||
-               (points.Length < 1) ||
-               (points[0] == Point.Empty))
-            {
-                return;
-            }
-
-            MultiPointShape shape = new MultiPointShape(
-                this.Controller.Model, 
-                points, 
-                MultiPointType.Polygon);
-
-            AddMultiPointShapeCommand cmd = new AddMultiPointShapeCommand(this.Controller, shape);
-            this.Controller.UndoManager.AddUndoCommand(cmd);
-            cmd.Redo();
-        }
-        #endregion
-
-        #region IKeyboardListener Members
-
-        public void KeyDown(KeyEventArgs e)
-        {       
-            if(e.KeyData == Keys.Escape && IsActive)
-            {
-                DeactivateTool();
-                Package();       
-                e.Handled = true;
-            }
-        }
-
-        public void KeyUp(KeyEventArgs e)
-        {
-        }
-
-        public void KeyPress(KeyPressEventArgs e)
-        {
-        }
-
-        #endregion
+    /// <summary>
+    /// Called when the tool is activated.
+    /// </summary>
+    protected override void OnActivateTool() {
+      Controller.View.CurrentCursor = CursorPalette.Cross;
+      this.SuspendOtherTools();
+      doDraw = false;
+      points = new Point[1];
     }
 
+    /// <summary>
+    /// Handles the mouse down event
+    /// </summary>
+    /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
+    /// <returns>Returns 'true' if the event was handled, otherwise 'false'.</returns>
+    public bool MouseDown(MouseEventArgs e) {
+      if (e == null)
+        throw new ArgumentNullException("The argument object is 'null'");
+      if (e.Button == MouseButtons.Left && Enabled && !IsSuspended) {
+        Array.Resize<Point>(ref points, points.Length + 1);
+        points[points.Length - 2] = e.Location;
+        doDraw = true;
+        return true;
+      }
+      return false;
+    }
+
+    /// <summary>
+    /// Handles the mouse move event
+    /// </summary>
+    /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
+    public void MouseMove(MouseEventArgs e) {
+      if (e == null)
+        throw new ArgumentNullException("The argument object is 'null'");
+      Point point = e.Location;
+      if (IsActive && doDraw) {
+        points[points.Length - 1] = e.Location;
+        Controller.View.PaintGhostLine(MultiPointType.Polygon, points);
+        //Controller.View.Invalidate(System.Drawing.Rectangle.Inflate(Controller.View.Ghost.Rectangle, 20, 20));
+        //TODO: find a more performant way to invalidate the area
+        Controller.View.Invalidate();
+      }
+    }
+    /// <summary>
+    /// 
+    /// </summary>
+    /// <param name="e">The <see cref="T:System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
+    public void MouseUp(MouseEventArgs e) {
+      if (IsActive) {
+
+      }
+    }
+    private void Package() {
+      if ((points == null) ||
+         (points.Length < 1) ||
+         (points[0] == Point.Empty)) {
+        return;
+      }
+
+      MultiPointShape shape = new MultiPointShape(
+          this.Controller.Model,
+          points,
+          MultiPointType.Polygon);
+
+      AddMultiPointShapeCommand cmd = new AddMultiPointShapeCommand(this.Controller, shape);
+      this.Controller.UndoManager.AddUndoCommand(cmd);
+      cmd.Redo();
+    }
+    #endregion
+
+    #region IKeyboardListener Members
+
+    public void KeyDown(KeyEventArgs e) {
+      if (e.KeyData == Keys.Escape && IsActive) {
+        DeactivateTool();
+        Package();
+        e.Handled = true;
+      }
+    }
+
+    public void KeyUp(KeyEventArgs e) {
+    }
+
+    public void KeyPress(KeyPressEventArgs e) {
+    }
+
+    #endregion
+  }
+
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/RectangleTool.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/RectangleTool.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Tools/RectangleTool.cs	(revision 4068)
@@ -1,108 +1,98 @@
-using System;
 using System.Drawing;
 using System.Windows.Forms;
 
-namespace Netron.Diagramming.Core
-{
-    // ----------------------------------------------------------------------
+namespace Netron.Diagramming.Core {
+  // ----------------------------------------------------------------------
+  /// <summary>
+  /// Tool to draw rectangles on the canvas.
+  /// </summary>
+  // ----------------------------------------------------------------------
+  public class RectangleTool : AbstractDrawingTool {
+    #region Fields
+
+    #endregion
+
+    #region Properties
+
+    #endregion
+
+    #region Constructor
+    public RectangleTool()
+      : base("Rectangle Tool") {
+    }
+    public RectangleTool(string name)
+      : base(name) {
+
+    }
+    #endregion
+
+    #region Methods
+
+    // ------------------------------------------------------------------
     /// <summary>
-    /// Tool to draw rectangles on the canvas.
+    /// Activates the tool - the cursor is set to the Icons.DrawRectangle.
     /// </summary>
-    // ----------------------------------------------------------------------
-    public class RectangleTool : AbstractDrawingTool
-    {
-        #region Fields
+    // ------------------------------------------------------------------
+    protected override void OnActivateTool() {
+      base.OnActivateTool();
+      Cursor = CursorPalette.DrawRectangle;
+    }
 
-        #endregion
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// Draws a ghost rectangle on the canvas if 'IsActive' and 'started'
+    /// is true.
+    /// </summary>
+    /// <param name="e">MouseEventArgs</param>
+    // ------------------------------------------------------------------
+    protected override void OnMouseMove(MouseEventArgs e) {
+      base.OnMouseMove(e);
+      if (IsActive && started) {
+        Point point = new Point(e.X, e.Y);
 
-        #region Properties
+        Controller.View.PaintGhostRectangle(startingPoint, point);
 
-        #endregion
+        Controller.View.Invalidate(System.Drawing.Rectangle.Inflate(
+            Controller.View.Ghost.Rectangle, 20, 20));
+      }
+    }
 
-        #region Constructor
-        public RectangleTool() : base("Rectangle Tool")
-        {
-        }
-        public RectangleTool(string name): base(name)
-        {
+    // ------------------------------------------------------------------
+    /// <summary>
+    /// This method will be called when the user has finished drawing a 
+    /// ghost rectangle or bundle and initiates the actual creation of a 
+    /// bundle and the addition to the model via the appropriate command.
+    /// </summary>
+    // ------------------------------------------------------------------
+    protected override void GhostDrawingComplete() {
+      if ((IsActive == false) ||
+          (started == false)) {
+        return;
+      }
 
-        }
-        #endregion
+      try {
+        SimpleRectangle shape = new SimpleRectangle(this.Controller.Model);
+        shape.Width = (int)Rectangle.Width;
+        shape.Height = (int)Rectangle.Height;
+        AddShapeCommand cmd = new AddShapeCommand(
+            this.Controller,
+            shape,
+            new Point((int)Rectangle.X, (int)Rectangle.Y));
 
-        #region Methods
+        this.Controller.UndoManager.AddUndoCommand(cmd);
+        cmd.Redo();
+      }
+      catch {
+        base.Controller.DeactivateTool(this);
+        Controller.View.Invalidate();
+        throw;
+      }
 
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Activates the tool - the cursor is set to the Icons.DrawRectangle.
-        /// </summary>
-        // ------------------------------------------------------------------
-        protected override void OnActivateTool()
-        {
-            base.OnActivateTool();
-            Cursor = CursorPalette.DrawRectangle;
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// Draws a ghost rectangle on the canvas if 'IsActive' and 'started'
-        /// is true.
-        /// </summary>
-        /// <param name="e">MouseEventArgs</param>
-        // ------------------------------------------------------------------
-        protected override void OnMouseMove(MouseEventArgs e)
-        {
-            base.OnMouseMove(e);
-            if (IsActive && started)
-            {
-                Point point = new Point(e.X, e.Y);               
-
-                Controller.View.PaintGhostRectangle(startingPoint, point);
-
-                Controller.View.Invalidate(System.Drawing.Rectangle.Inflate(
-                    Controller.View.Ghost.Rectangle, 20, 20));
-            }
-        }
-
-        // ------------------------------------------------------------------
-        /// <summary>
-        /// This method will be called when the user has finished drawing a 
-        /// ghost rectangle or bundle and initiates the actual creation of a 
-        /// bundle and the addition to the model via the appropriate command.
-        /// </summary>
-        // ------------------------------------------------------------------
-        protected override void GhostDrawingComplete()
-        {
-            if ((IsActive == false) ||
-                (started == false))
-            {
-                return;
-            }
-
-            try
-            {
-                SimpleRectangle shape = new SimpleRectangle(this.Controller.Model);
-                shape.Width = (int) Rectangle.Width;
-                shape.Height = (int) Rectangle.Height;
-                AddShapeCommand cmd = new AddShapeCommand(
-                    this.Controller, 
-                    shape, 
-                    new Point((int) Rectangle.X, (int)Rectangle.Y));
-
-                this.Controller.UndoManager.AddUndoCommand(cmd);
-                cmd.Redo();
-            }
-            catch
-            {
-                base.Controller.DeactivateTool(this);
-                Controller.View.Invalidate();
-                throw;
-            }
-
-            //base.Controller.DeactivateTool(this);
-        }
+      //base.Controller.DeactivateTool(this);
+    }
 
 
-        #endregion
-    }
+    #endregion
+  }
 
 }
